#pragma once

typedef void unknown; // used only by the command definitions, any type is accepted if you see this

// Used internally!
void TK_IF(int, int);
void TK_ELSE(int);
void TK_ENDIF();
void TK_WHILE(int, int);
void TK_ENDWHILE(int);
void TK_FOR(int, int);
void TK_ENDFOR(int);
void TK_CONTINUE(int);
void TK_BREAK(int);
void TK_GOTO(int);
void TK_SWITCH(int, unknown);
void TK_ENDSWITCH();
void TK_CASE();
void TK_DEFAULT();
void TK_RETURN();
void TK_RETURN(int);
void TK_RETURN(loc);
void TK_RETURN(obj);
void TK_RETURN(string);

// Used internally!?
int oprnull(int);
int oprplus(int, int);
int oprminus(int, int);
int oprmult(int, int);
int oprdiv(int, int);
int oprand(int, int);
int opror(int, int);
int oprxor(int, int);
int oprequiv(int, int);
int oprnequiv(int, int);
int oprgt(int, int);
int oprlt(int, int);
int oprmod(int, int);
int oprgteq(int, int);
int oprlteq(int, int);
int oprnot(int);
unknown oprlist(list, int);
list oprlist(list, int);
int oprlist(list, int);
string oprlist(list, int);
ustring oprlist(list, int);
loc oprlist(list, int);
obj oprlist(list, int);
string oprlist(string, int);
void oprinc(int &);
void oprdec(int &);
string oprplus(string, string);
string oprplus(string, int);
string oprplus(string, loc);
int oprequiv(string, string);
int oprnequiv(string, string);
int oprequiv(loc, loc);
int oprnequiv(loc, loc);
int oprequiv(obj, obj);
int oprnequiv(obj, obj);
void assignint(int &, int);
void assignstr(string &, string);
void assignustring(ustring &, ustring);
void assignobj(obj &, obj);
void assignloc(loc &, loc);
void assignlist(list, list);

// Commands...
void append(list, unknown);
void appendToList(list, unknown);
void prepend(list, unknown);
void prependToList(list, unknown);
void insert(list, unknown, int);
void insertInList(list, unknown, int);
int numinlist(list &);
int numInList(list);
int isinlist(list, unknown);
int isInList(list, unknown);
void setitem(list, unknown, int);
void setItem(list, unknown, int);
void setLocItem(list, loc, int);
void concatList(list, list);
void truncateList(list, int);
void removeitem(list, int);
void removeItem(list, int);
void removespecificitem(list, unknown);
void removeSpecificItem(list, unknown);
void clearlist(list);
void clearList(list);
void printList(list);
int getListItemType(list &, int);
void copylist(list, list);
void copyList(list, list);
void sortList(list, int);
int isArrayInit(int);
void initArray(int, int, int, list);
void initArrayFromFile(int, int, int, string);
void deleteArray(int);
void setArrayIntElem(int, int, int, int);
void setArrayStrElem(int, int, int, string);
void setArrayUStrElem(int, int, int, ustring);
void setArrayElemns(int, int, int, list);
int getArrayIntElem(int, int, int);
string getArrayStrElem(int, int, int);
ustring getArrayUStrElem(int, int, int);
int getArrayWidth(int);
int getArrayHeight(int);
void assignintstr(int &, string);
void assignstrint(string &, int);
void assignustringint(ustring &, int);
void assignlocint(loc &, int, int, int);
int objtoint(obj);
void split(list, string);
int wordWrap(list, string, int);
int textSubstitute(string &, string, string, string);
void split(list, string);
void splitCommaDelimitedString(list, string);
void concat(string, string);
void barkstr(string);
void barkint(int);
int strtoi(string);
int strlen(string);
void toUpper(string &, int, int);
void removePrefix(string &, string);
int getCompileFlag(int);
void sendToNearbyPlayers(obj, int);
void targetobj(obj, obj);
void targetobj(obj, obj);
void targetloc(obj, obj);
void targetloc(obj, obj);
void supertargetobj(obj, obj, int);
void superTargetObj(obj, obj, int);
void supertargetloc(obj, obj, int, int);
void superTargetLoc(obj, obj, int, int);
void targetlocmulti(obj, obj, int, int, int, int);
void targetLocMulti(obj, obj, int, int, int, int);
void targetLocObjList(obj, obj, int, int, int, list);
void addfrag(obj, string);
void addFrag(obj, string);
void addfragment(obj, string);
void addFragment(obj, string);
void removefragment(obj, string);
void removeFragment(obj, string);
int hasscript(obj, string);
int hasScript(obj, string);
void attachscript(obj, string);
void attachScript(obj, string);
void detachscript(obj, string);
void detachScript(obj, string);
void getScripts(list, obj);
void getcontents(list, obj);
void getContents(list, obj);
void getequipment(list, obj);
void getEquipment(list, obj);
void callback(obj, int, int);
void callBack(obj, int, int);
void shortcallback(obj, int, int);
void shortCallback(obj, int, int);
void removeCallback(obj, int);
void removeCallbackAdvanced(obj, int, int);
int hasCallback(obj, int);
int hasCallbackAdvanced(obj, int, int);
void callbackAdvanced(obj, int, int, int);
void selectType(obj, obj, int, string, list);
void selectTypeAndHue(obj, obj, int, string, list);
void selectHue(obj, obj, int, int);
void message(obj, string, list);
int messageret(obj, obj, string, list);
void multimessage(obj, string, list);
void multiMessage(obj, string, list);
void multiMessageToLoc(loc, string, list);
void multiMessageToRange(loc, int, string, list);
void messageToRange(loc, int, string, list);
int hasObjVar(obj, string);
int hasObjListVar(obj, string);
unknown getObjVar(obj, string);
int getObjVar(obj, string);
string getObjVar(obj, string);
loc getObjVar(obj, string);
obj getObjVar(obj, string);
int getobjvar|int(obj, string);
string getobjvar_str(obj, string);
loc getobjvar_loc(obj, string);
obj getobjvar_obj(obj, string);
void getObjListVar(list, obj, string);
void setObjVar(obj, string, unknown);
void removeObjVar(obj, string);
void copyObjVar(obj, obj, string);
void copyAllObjVars(obj, obj);
int addToObjVarListSet(obj, string, unknown);
int isInObjVarListSet(obj, string, unknown);
void changeLoc(loc &, int, int, int);
obj NULL();
void setDefaultReturn(int);
void setConvoRet(string);
void disableBehaviors(obj);
void enableBehaviors(obj);
int areBehaviorsEnabled(obj);
void callGuards(obj, loc, int);
void seance(obj, int);
void setLastValidTerrainLoc(obj, loc);
int teleport(obj, loc);
int teleportNoFall(obj, loc);
int random(int, int);
int dice(int, int);
void deleteObject(obj);
void deleteObjectNoFall(obj);
int putObjContainer(obj, obj);
int toMobile(obj, obj);
int putObjBank(obj, obj);
int putMobContainer(obj, obj);
int withdrawFromBank(obj, int);
int withdrawAndDestroy(obj, int);
void openBank(obj);
int depositIntoBank(obj, obj, int);
int amtGoldInBank(obj);
int equipObj(obj, obj, int);
int dropObj(obj, loc);
int findGoodSpotNearWithElev(loc &, int, int, int, int, int);
int findGoodSpotNear(loc &, int, int, int);
int findGoodSpotNearMin(loc &, int, int, int, int, int);
int findGoodZ(loc, int, int, int, int);
int canExistAt(loc, int, int);
int walk(obj, int);
int run(obj, int);
void setType(obj, int);
void setHue(obj, int);
void setPartialHue(obj, int);
void setDefaultTextHue(obj, int);
int getDefaultTextHue(obj);
void animateMobile(obj, int, int, int, int, int);
void sfx(loc, int, int);
void sfxTo(obj, int, int);
void musicTo(obj, int);
int getDirectionInternal(loc, loc);
string getDirection(loc, loc);
int getDistanceInTiles(loc, loc);
string getDistance(loc, loc);
loc interpose(loc, loc);
int getFacing(obj);
int getHue(obj);
int isFacingPlace(obj, loc);
int isFacingPerson(obj, obj);
int facingEachOther(obj, obj);
void faceHere(obj, int);
int getSex(obj);
int sameSex(obj, obj);
int isHumanBodyType(obj);
int isHuman(obj);
int isMobile(obj);
int isPlayer(obj);
int isSpellbook(obj);
int isContainer(obj);
int isRealContainer(obj);
int isMap(obj);
int isNPC(obj);
int isOwnedPet(obj);
int isShopKeeper(obj);
int isGuard(obj);
int isDead(obj);
int isInContainer(obj);
int isEquipped(obj);
int isMoveable(obj, obj);
int isFreelyUsable(obj, obj);
int isFreelyViewable(obj, obj);
int isOnline(obj);
obj containedBy(obj);
obj getTopmostContainer(obj);
int isNoDrawType(int);
void bark(obj, string);
void ebark(obj, string);
void barkTo(obj, obj, string);
void ebarkTo(obj, obj, string);
void barkToHued(obj, obj, int, string);
void bark(obj, ustring);
void ebark(obj, ustring);
void barkTo(obj, obj, ustring);
void ebarkTo(obj, obj, ustring);
void barkToHued(obj, obj, int, string);
void actionBark(obj, int, string, string);
int getObjType(obj);
int getValue(obj);
int makeValueless(obj);
int isInCamp(obj);
int getWeight(obj);
loc getLocation(obj);
loc getRelayLoc(obj);
loc whereIs(obj);
loc getMasterObjLoc(int);
int numInContainer(obj);
int isRidable(obj);
int isRiding(obj);
int isVritueGuard(obj);
int isOrderGuard(obj);
int isChaosGuard(obj);
int isUsingVirtueShield(obj);
int unRide(obj);
int getAC(obj);
int getMovementType(obj);
void setMovementType(obj, int);
int getGeneric(obj, int);
int getMoney(obj);
void gainFame(obj, int);
void loseFame(obj, int);
int NotorietyCompare(obj, obj);
int notorietyCompare(obj, obj);
void addNotoriety(obj, int);
void removeNotoriety(obj, int);
int getNotoriety(obj);
int getNotorietyLevel(obj);
int getNotorietyLevelByNot(int);
void setNotoriety(obj, int);
int getFame(obj);
int getAdjFame(obj);
int getFameLevel(obj);
void changeFame(obj, int);
void setFame(obj, int);
int getKarma(obj);
int getAdjKarma(obj);
int getKarmaLevel(obj);
void changeKarma(obj, int);
void setKarma(obj, int);
int getCurHP(obj);
int getMaxHP(obj);
int getCurFatigue(obj);
int getMaxFatigue(obj);
int getCurMana(obj);
int getMaxMana(obj);
int getCanCarry(obj);
int getSkillTotal(obj);
int getCappedSkillTotal(obj);
int getNaturalAC(obj);
int getHPLevel(obj);
int getFatigueLevel(obj);
int getManaLevel(obj);
void setCurHP(obj, int);
void setMaxHP(obj, int);
void handleHealthGain(obj);
void setCurFatigue(obj, int);
void setMaxFatigue(obj, int);
void setCurMana(obj, int);
void setMaxMana(obj, int);
void setNaturalAC(obj, int);
void addHP(obj, int);
void addMana(obj, int);
void addFatigue(obj, int);
void doDamageWithWeapon(obj, obj, obj, int);
void doDamage(obj, obj, int);
void doDamageFight(obj, obj, int, int);
void doDamageType(obj, obj, int, int);
void loseHP(obj, int);
void loseMana(obj, int);
void loseFatigue(obj, int);
void restoreMobile(obj);
void restoreFatigue(obj);
void restoreHP(obj);
void restoreMana(obj);
string getHeShe(obj);
string getHimHer(obj);
string getHisHer(obj);
int hasObjEquipped(obj, obj);
int hasObjTypeEquipped(obj, int);
int getEquipSlot(obj);
obj getItemAtSlot(obj, int);
obj getWeapon(obj);
int isArmed(obj);
int getFreeHandSlot(obj);
int getYear();
int getMonth();
int getWeek();
int getDay();
int getHour();
int getMinute();
int getSeconds();
int isWeapon(obj);
int isReallyWeapon(obj);
int getSatiety(obj);
int getRealStrength(obj);
int getRealDexterity(obj);
int getRealIntelligence(obj);
int getStrength(obj);
int getDexterity(obj);
int getIntelligence(obj);
int getStat(obj, int);
int getRealStat(obj, int);
int getStatAttributeMax(obj, int);
int setStatAttributeMax(obj, int, int);
int modifyStat(obj, int, int);
int modifyRealStat(obj, int, int);
int setRealStat(obj, int, int);
int getStatMod(obj, int);
int setStatMod(obj, int, int);
int getSkillMod(obj, int);
int setSkillMod(obj, int, int);
void addSatiety(obj, int);
int testSkill(obj, int);
int skillTest(obj, int);
int testSkillReal(obj, int);
int skillTestReal(obj, int);
int getSkillLevel(obj, int);
int getSkillLevelReal(obj, int);
int getSkillLevelRealStat(obj, int);
int getSkillLevelNoStat(obj, int);
int getSkillLevelNoStatNoMod(obj, int);
void setSkillLevel(obj, int, int);
void addSkillLevel(obj, int, int);
void loseSkillLevel(obj, int, int);
int modifySkillMod(obj, int, int);
void setMobFlag(obj, int, int);
int getMobFlag(obj, int);
int getSkillNumber(string);
string getSkillName(int);
string getOrcishSyllable(int);
string getWispishSyllable(int);
string getLizardishSyllable(int);
string getRattishSyllable(int);
void handleWatchingSkill(obj, int);
int testAndLearnSkill(obj, int, int, int);
int getSkillSuccessChance(obj, int, int, int);
obj getBackpack(obj);
obj transferGenericToContainer(obj, obj, int, int);
obj transferGenericToWorld(loc, obj, int, int);
void destroyGeneric(obj, int, int);
obj takeMoney(obj, int);
obj giveItem(obj, obj);
void systemMessage(obj, string);
void systemMessageHued(obj, int, string);
int textMessage(obj, string, int, int, int);
int superBark(obj, string, int, int, int);
void getMobsInRange(list, loc, int);
void getMobsInRangeOld(list, loc, int);
int objIsInRange(loc, int);
void getObjectsInRange(list, loc, int);
void getObjectsInRangeWithFlags(list, loc, int, int);
int getNumAllObjectsInRangeWithFlags(loc, int, int);
int getObjectFlags(obj, int);
int getTerrainFlags(int, int);
void getObjectsInRangeOfType(list, loc, int, int);
void getObjectsInSpecRange(list, loc, int, int);
obj getFirstObjectOfType(loc, int);
obj getNextObjectOfType(loc, int, obj);
void getPlayersInRange(list, loc, int);
void getNPCsInRange(list, loc, int);
void getNPCsInRangeOld(list, loc, int);
int getTileAt(loc);
int isInMap(loc);
int isInWorld(loc);
int getTileHeight(int);
void getMobsAt(list, loc);
void getPlayersAt(list, loc);
void getNPCsAt(list, loc);
void getObjectsAt(list, loc);
void getObjectsAtInZRange(list, loc, int, int);
int getQuantity(obj);
int getMiscData(obj);
int getQuality(obj);
int getHeight(obj);
int getSurfaceHeight(obj);
void logOut(obj);
void safeLogOut(obj);
void safeLogout(obj);
void setHidden(obj, int);
int isHidden(obj);
void openGump(obj, int);
void closeGump(obj, int);
void doMissile_Loc2Loc(loc, loc, int, int, int, int);
void doMissile_Loc2Mob(loc, obj, int, int, int, int);
void doMissile_Mob2Loc(obj, loc, int, int, int, int);
void doMissile_Mob2Mob(obj, obj, int, int, int, int);
void doLocAnimation(loc, int, int, int, int, int);
void doMobAnimation(obj, int, int, int, int, int);
void doLightning(obj);
void beginSequence();
void endSequence(int);
int waitState(obj);
void setWaitState(obj, int);
int isInvisible(obj);
void setInvisible(obj, int);
void setPoisoned(obj, int);
void setCursed(obj, int);
string getName(obj);
string getRealName(obj);
void setRealName(obj, string);
void setRealNameFromTemplate(obj, int);
string getTitledName(obj);
void walkTo(obj, loc, int);
int canSeeObj(obj, obj);
int getElevationAt(int, int);
int canExistAt(loc, int, int);
int canSeeLoc(obj, loc);
int isValid(obj);
int getTemplate(obj);
int getDefaultAlignment(int);
void setAlignment(obj, int);
void becomeTemplate(obj, int);
int isAtHome(obj);
int thinksItsAtHome(obj);
int hasHome(obj);
loc getHome(obj);
void setHome(obj, loc);
loc getCreationLoc(obj);
void getStaticObjectsAt(list, loc);
void getStaticObjectsAtXY(list, loc);
void getStaticObjectsAtXYZ(list, loc);
void shopKeeperOpenBusiness(obj, obj);
void shopKeeperOpenBuying(obj, obj);
int hasShopKeyword(list);
int mobileWillBuy(obj, obj);
string getNameByType(int);
int getX(loc);
int getY(loc);
int getZ(loc);
void setX(loc &, int);
void setY(loc &, int);
void setZ(loc &, int);
void moveDir(loc &, int);
void debugMessage(string);
void replyTo(obj, obj, string);
void replyToMobAbout(obj, obj, obj, string);
void returnObject(obj);
int containsObj(obj, obj);
obj containsObjType(obj, int);
int mobileContainsObj(obj, obj);
void getObjectsOfTypeIn(list, obj, int);
obj mobileContainsObjType(obj, int);
void getContainersOnMobile(list, obj);
void useItem(obj, obj);
void doLookAt(obj, obj);
string getArticle(int);
string objToStr(obj);
void scoreToSpace(string);
void scriptTrig(obj, int, obj);
void processTriggerCmds(obj, string);
void deleteIfValid(obj, int);
void deleteIfValidNoFall(obj, int);
void createPlaceHolder(obj);
int changeRange(obj, int, int, int);
int findClosestArea(string &, loc &, string, loc, int);
int isInArea(string, loc, int);
void setLooksLikeTemplate(obj, int);
void followNpc(obj, obj, int);
void stopFollowing(obj);
obj getLeader(obj);
void runAway(obj, obj);
int getHungerLevel(obj);
void setDesireLevel(obj, int);
int eatObject(obj, obj);
void setBehavior(obj, int);
void clearBehavior(obj, int);
void loiter(obj, int);
void goLoiter(obj, loc, int);
int getDesireLevel(obj);
void setLoiterMode(obj, int);
int getLightVal(obj);
int getLightTime(obj);
void setLight(obj, int, int);
int getResource(int &, obj, string, int, int);
int getResourcesOnObj(obj, int, list);
string getResourceName(string, int);
int getResourceTypeIdByName(int &, string);
int hasResource(obj, int);
int hasObj(obj, obj);
int hasObjType(obj, int);
int hasObjTypeInBank(obj, int);
void callGuards(obj, obj, int);
int witnessCrime(loc, obj, obj, string, int, int, int);
void criminalAct(obj, obj, int, int);
void criminalActAdvanced(obj, obj, int, int, int, int);
void committedCrimeAt(obj, loc, int);
void setCriminal(obj, int);
int isCriminal(obj);
int isMurderer(obj);
int getMurderCount(obj);
void setMurderCount(obj, int);
void setResurrectionResources(obj);
int canBeFreelyAggressedBy(obj, obj);
void refreshAggression(obj);
void receiveAggressionFrom(obj, obj);
void receiveUnhealthyActionFrom(obj, obj);
void receiveHelpfulActionFrom(obj, obj);
void copyControllerInfo(obj, obj);
int openContainer(obj, obj);
void updateHint(int, obj, int, string, string, loc, obj, string, int);
int getHint(obj, int, int &, obj &, int &, string &, string &, loc &, obj &, string &, int &);
int getLocalizedDesc(string &, loc &, loc, loc);
int getSmallestArea(string &, loc);
int isInRegionWithPrefix(string &, loc);
int getTrammelPhase();
int getFeluccaPhase();
string getMoonPhaseStr(int);
int getMoonGateDest(int);
int canWield(obj, obj);
int isSlashing(obj);
int isPiercing(obj);
int isBashing(obj);
int isRanged(obj);
int getMaxArmorClass(obj);
int getCurArmorClass(obj);
int getAmmoType(obj);
int getBow(obj);
int setMaxArmorClass(obj, int);
int getWeaponRange(obj);
int getWeaponMinRange(obj);
int getWeaponHandedness(obj);
string getWeaponName(obj);
int getAverageDamage(obj);
void getWeaponClass(obj, int &, int &, int &, int &);
void setWeaponClass(obj, int, int, int, int);
int getWeaponCurHP(obj);
int setWeaponCurHP(obj, int);
int getWeaponMaxHP(obj);
int setWeaponMaxHP(obj, int);
int getWeaponMinStr(obj);
int getWeaponSpeed(obj);
int getWeaponHitSfx(obj);
int getWeaponMissSfx(obj);
int applyWeaponTemplate(obj, int);
void makeDice(string &, string, int, int, string, int);
void splitDice(string, string &, int &, int &, string &, int &);
void attack(obj, obj);
void peace(obj);
void stopAttack(obj);
void stopFight(obj, obj);
void getTargets(list, obj);
void getVisableTargets(list, obj);
obj getFirstVisableTarget(obj);
obj getFirstVisibleTargetInRange(obj, int);
void getAttackers(list, obj);
void getAttackersNearby(list, obj);
int getNumTargets(obj);
int & getNumAttackers(obj);
obj getFirstTarget(obj);
obj makeMultiInst(loc, int);
obj makeMultiInstCheck(loc, int, int, int, int &, int, int, int);
int moveMulti(obj, loc);
int moveMultiCheck(obj, loc, int);
int recycleMulti(obj, int);
int recycleMultiCheck(obj, int, int);
int recycleMultiCheckRotate(obj, int, int, int);
int moveMultiMapSwitch(obj, loc, int);
int isMultiComp(obj);
int isMultiSlave(obj);
obj getMultiSlaveId(obj);
loc getMultiComponentOffset(obj);
int areObjectsOn(obj);
int getMultiExtents(int, loc &, loc &);
int isHousingOkay(loc, int);
int areSpellsOkay(loc);
int isInCityRegion(loc);
int inJustringiceRegion(loc);
int getMultiType(obj);
void resetMultiCarriedDecay(obj);
int multiCanExistAt(loc, int, int);
int canMultiExistAt(obj, loc, int);
int dropCheck(loc &, obj, int);
int isOnMulti(obj, obj);
obj isOnAnyMulti(obj);
obj isAnyMultiAt(loc);
obj isAnyMultiBelow(loc);
int getNumInMultiType(int);
void multiCompSetSendSlave(obj, int);
int areMobilesInMultiArea(int, loc);
void getPlayersOnMulti(list, obj);
void getObjectsOnMulti(list, obj);
void sendPlayerZmoveStuff(obj);
int getDecayCount(obj);
int getDecayMax(obj);
int setDecayCount(obj, int);
int getHomeDecayRate();
int getNonHomeDecayRate();
int getDefaultDieDecay();
int getDecayInternval();
obj mobileHasObjWithListObjOfObj(obj, string, obj);
int getPulseNum();
void setDecayTest(int);
obj getClosestMobile(loc, int);
obj getClosestPlayer(loc, int);
obj getClosestOnlinePlayer(loc, int);
obj getClosestMobileOrOnlinePlayer(loc, int);
obj getClosestVisibleOnlinePlayer(loc, int);
void setMapProperties(obj, int, int, int, int, int, int, int);
int isValidMap(obj);
int isMap(obj);
int getMapPointer(loc &, obj, int);
int copybook(obj, obj);
int setNPCState(obj, int);
int getNPCState(obj);
int goSleep(obj, int, int);
void transferAllResources(obj, obj);
void transferResources(obj, obj, int, string);
void transferGeneric(obj, obj, int);
void returnAllResourcesToBank(obj);
void returnResourcesToBank(obj, int, string);
obj createGlobalNPCAt(int, loc, int);
obj createGlobalNPCAtSpecificLoc(int, loc);
obj createGlobalObjectAt(int, loc);
obj createGlobalObjectIn(int, obj);
obj createGlobalObjectOn(obj, int);
obj createNoResObjectAt(int, loc);
obj createNoResObjectIn(int, obj);
obj requestCreateObjectAt(int, loc);
obj requestCreateObjectIn(int, obj);
obj requestCreateNPCAt(int, loc, int);
int defineResource(obj, string, int, int, int);
obj getChunkEgg(loc);
void addGlobalQuantity(obj, int);
int requestAddQuantity(obj, int);
void addConsumer(loc &, string, int, int);
int whoIsLargestConsumer(loc, int);
int resourceTypeToId(string);
int isGeneric(obj);
int canBeGeneric(obj);
void destroyOne(obj);
string getROBookTitle(int);
int getBookPages(obj);
void removeLeadingWords(string &, int);
obj findClosestBBoard(loc);
void setPostTime(obj);
int getTimeSecs();
int objsNearby(list, loc &, int, int);
void intRet(int);
void textEntry(obj, obj, int, int, string);
void stringQuery(obj, obj, int, string, int, int, int, string);
void webBrowse(obj, string);
void makeBeelineFailPathFind(obj, int);
void overloadWeight(obj, int);
void recalcWeight(obj);
void fixBank(obj);
void setStatus(obj, int, int);
int getStatus(obj, int);
int isHair(obj);
int isEditing(obj);
int isCounselor(obj);
int isGameMaster(obj);
int getPlayerBugStat(list, int);
int doNPCHeartBeat(obj);
int doNPCHandleStates(obj);
int isManifesting(obj);
void addHelpRequestToQueue(obj, int, int, string);
int removePlayerFromGame(obj);
void trackingTypeSelected(list, obj, int, int, loc);
obj doTakeMoney(obj, int, int);
void doSCommand(obj, string);
int resurrect(obj, int);
void destroyContents(obj);
int canHold(obj, obj);
void transferPlayer(obj, obj, string);
void checkTransferAccount(obj, obj);
int getGMCallStatus();
void setGMCallStatus(int);
int getEncumbrance(obj);
void getCurrentTimeStr(string);
void setROBookNum(obj, int);
int getPlayAge(obj);
int isCorpse(obj);
int getCorpseBodyType(obj);
int isObscene(string);
void logEntry(int, int, obj, string, string, string, string);
int getAccountNum(obj);
int getCharacterNum(obj);
int getCombatMode(obj);
int isInvulnerable(obj);
void makeInvulnerable(obj);
void makeVulnerable(obj);
void openGenericGump(obj, obj, int, int, int, list, list);
void setTile(loc, int);
int getTile(loc);
void setElevation(loc, int);
int getElevation(loc);
void createStatic(loc, int);
void createStaticHued(loc, int, int);
void updatesOn();
void updatesOff();
void escript(obj, string, string);
int abs(int);
int isGoldAccount(obj);
